<?php
$previous_button = $next_button = "";
$upload_dir = wp_upload_dir();
if ($result_page > 0) {
	$previous_page = $result_page - 2;
	$previous_button = '<a class="button" id="prev_page" href="?' . $admin_page . 'result_page=' . $previous_page . '">' . $options['previous_button_text'] . '</a> ';
	if ($results_remaining > $table_limit) {
		$next_button = '<a class="button" id="next_page" href="?' . $admin_page . 'result_page=' . $result_page . '">' . $options['next_button_text'] . '</a> ';
	}
} else if (0 == $result_page) {
	if ($results_remaining > $table_limit) {
		$next_button = '<a class="button" id="next_page" href="?' . $admin_page . 'result_page=' . $result_page . '">' . $options['next_button_text'] . '</a> ';
	}
} else if ($results_remaining < $table_limit) {
	$previous_page = $results_remaining - 2;
	$previous_button = '<a class="button" id="prev_page" href="?' . $admin_page . 'result_page=' . $previous_page . '">' . $options['previous_button_text'] . '</a> ';
}
?>
<div class="user-dashboard-pagination">
	<span class="previous-button"><?php echo $previous_button;?></span>
	<span class="next-button"><?php echo $next_button;?></span>
</div>
<table class="widefat user-dashboard-list">
	<thead>
		<tr>
			<th>&nbsp;</th>
			<?php if (1 == $options['quiz_name_check']): ?>
				<th><?php echo $options['quiz_name_text']; ?></th>
			<?php endif; ?>
			<?php if (1 == $options['quiz_score_check']): ?>
				<th><?php echo $options['quiz_score_text']; ?></th>
			<?php endif; ?>
			<?php if (1 == $options['quiz_time_check']): ?>
				<th><?php echo $options['quiz_time_text']; ?></th>
			<?php endif; ?>
			<?php if (isset($options['quiz_time_to_complete_check']) && 1 == $options['quiz_time_to_complete_check']): ?>
				<th><?php echo $options['quiz_time_to_complete_text']; ?></th>
			<?php endif; ?>
			<?php if (isset($options['quiz_certificate_link_check']) && 1 == $options['quiz_certificate_link_check']): ?>
				<th><?php echo $options['quiz_certificate_link_text']; ?></th>
			<?php endif; ?>
		</tr>
	</thead>
	<tbody>
		<?php
		foreach ($user_results as $result) {
			$mlw_qmn_results_array = @unserialize($result->quiz_results);
			?>
			<tr class="alternate">
				<td><span style='color:green;font-size:16px;'><a href="javascript:show_results(<?php echo $result->result_id; ?>);"><?php echo $options['view_text']; ?></a></span></td>
				<?php if (1 == $options['quiz_name_check']): ?>
					<td><span style='font-size:16px;'><?php echo $result->quiz_name ?></span></td>
				<?php endif; ?>
				<?php if (1 == $options['quiz_score_check']): ?>
					<td class="post-title column-title">
						<span style='font-size:16px;'>
							<?php
							if (isset($result->form_type) && ( $result->form_type == 1 || $result->form_type == 2 )) {
								_e('Not Graded', 'qsm-user-dashboard');
							} else {
								if (0 == $result->quiz_system) {

									echo apply_filters( 'quiz_score_user_dashboard', $result->correct . __(" out of ", 'qsm-user-dashboard') . $result->total . __(" or ", 'qsm-user-dashboard') . $result->correct_score . "%", $result);

								} elseif (1 == $result->quiz_system) {

									echo apply_filters( 'quiz_score_user_dashboard', $result->point_score . __(" Points", 'qsm-user-dashboard'), $result);

								} elseif (3 == $result->quiz_system) {

									echo apply_filters( 'quiz_score_user_dashboard', $result->correct . __(" out of ", 'qsm-user-dashboard') . $result->total . __(" or ", 'qsm-user-dashboard') . $result->correct_score . "%<br/>" . $result->point_score . __(" Points", 'qsm-user-dashboard') . "", $result);
								}
							}
							?>
						</span>
					</td>
				<?php endif; ?>
				<?php if (1 == $options['quiz_time_check']): ?>
					<td><span style='font-size:16px;'><?php echo apply_filters( 'quiz_time_user_dashboard', date("m-d-Y h:i:s A", strtotime($result->time_taken) ),$result );?></span></td>
					<?php endif; ?>
				<?php if (isset($options['quiz_time_to_complete_check']) && 1 == $options['quiz_time_to_complete_check']): ?>
					<td>
						<?php
						if (is_array($mlw_qmn_results_array) && isset($mlw_qmn_results_array[0])) {
							$mlw_complete_hours = floor($mlw_qmn_results_array[0] / 3600);
							if ($mlw_complete_hours > 0) {
								$hour_label = $mlw_complete_hours == 1 ? __('Hour', 'qsm-user-dashboard') : __('Hours', 'qsm-user-dashboard');
								echo "<span class='qsm-ud-hour-span' style='font-size:16px;'>" . str_pad($mlw_complete_hours, 2, '0', STR_PAD_LEFT) . " " . $hour_label . "</span>";
							} else {
								echo "<span class='qsm-ud-hour-span' style='font-size:16px;'>0 " . __('Hour', 'qsm-user-dashboard') . "</span>";
							}
							echo ' ';
							$mlw_complete_minutes = floor(($mlw_qmn_results_array[0] % 3600) / 60);
							if ($mlw_complete_minutes > 0) {
								$min_label = $mlw_complete_minutes == 1 ? __('Minute', 'qsm-user-dashboard') : __('Minutes', 'qsm-user-dashboard');
								echo "<span class='qsm-ud-min-span' style='font-size:16px;'>" . str_pad($mlw_complete_minutes, 2, '0', STR_PAD_LEFT) . " " . $min_label . "</span>";
							} else {
								echo "<span class='qsm-ud-min-span' style='font-size:16px;'>0 " . __('Minute', 'qsm-user-dashboard') . "</span>";
							}
							echo ' ';
							$mlw_complete_seconds = $mlw_qmn_results_array[0] % 60;
							$sec_label = $mlw_complete_seconds == 1 ? __('Second', 'qsm-user-dashboard') : __('Seconds', 'qsm-user-dashboard');
							echo "<span class='qsm-ud-second-span' style='font-size:16px;'>" . str_pad($mlw_complete_seconds, 2, '0', STR_PAD_LEFT) . " " . $sec_label . "</span>";
						} else {
							echo "-";
						}
						?>
					</td>
				<?php endif; ?>
				<?php if (isset($options['quiz_certificate_link_check']) && 1 == $options['quiz_certificate_link_check']): ?>
					<td>
						<?php
						$encoded_time_taken = md5($result->time_taken);
						$certifacate_name = "{$result->quiz_id}-{$mlw_qmn_results_array[0]}-{$encoded_time_taken}-{$result->point_score}-{$result->correct_score}";
						$certificates = scandir($upload_dir['basedir'] . "/qsm-certificates/");
						array_shift($certificates);
						array_shift($certificates);
						foreach($certificates as $certificate){
							$certi_exists = strpos($certificate, $certifacate_name);
							if($certi_exists === 0){
								$certifacate_name = $certificate;
								break;
							}
						}
						if ($certifacate_name && file_exists($upload_dir['basedir'] . "/qsm-certificates/" . $certifacate_name)) {
							$certificate_url = $upload_dir['baseurl'] . "/qsm-certificates/$certifacate_name";
							echo "<a target='_blank' href='$certificate_url' class='qmn_certificate_link'>" . __('Download Certificate', 'qsm-user-dashboard') . "</a>";
						} else {
							echo "-";
						}
						?>
					</td>
				<?php endif; ?>
			</tr>
			<?php
		}
		?>
	</tbody>
</table>